format MS COFF

public _ExitProcess@4
public _HeapAlloc@12
public _HeapCreate@12
public _HeapDestroy@4
public _HeapFree@12
public _GetModuleHandleA@4
public _SetCurrentDirectoryA@4
public _memset

section '.code' align 16

;**********************************************************************************
align 16
_ExitProcess@4:
        mov    eax, 0xffffffff
        int    64
        ; ret not need
;**********************************************************************************
align 16
_HeapAlloc@12:
hHeap          equ [esp +  4 +1*4]
dwFlags        equ [esp +  8 +1*4]
dwBytes        equ [esp + 12 +1*4]
        push   ebx

        mov    eax, 68
        mov    ebx, 12
        mov    ecx, dwBytes
        int    64

        pop    ebx
        ret    12
restore hHeap
restore dwFlags
restore dwBytes
;**********************************************************************************
align 16
_HeapCreate@12:
flOptions      equ [esp +  4 +1*4] ; Optional attributes for the new heap
dwInitialSize  equ [esp +  8 +1*4] ; initial amount of physical storage allocated for heap
dwMaximumSize  equ [esp + 12 +1*4] ; maximum size, in bytes, of the heap
        push   ebx

        mov    eax, 68
        mov    ebx, 11
        int    64

        pop    ebx
        ret    12
restore flOptions
restore dwInitialSize
restore dwMaximumSize
;**********************************************************************************
align 16
_HeapDestroy@4:
hHeap          equ [esp +  4] ; handle to  heap to be destroyed
        mov    eax, 0xffffffff
        ret    4
restore hHeap
;**********************************************************************************
align 16
_HeapFree@12:
hHeap          equ [esp +  4 +1*4]
dwFlags        equ [esp +  8 +1*4]
lpMem          equ [esp + 12 +1*4]
        push   ebx

        mov    eax, 68
        mov    ebx, 13
        mov    ecx, lpMem
        int    64

        pop    ebx
        ret    12
restore hHeap
restore dwFlags
restore lpMem
;**********************************************************************************
align 16
_GetModuleHandleA@4:
lpModuleName   equ [esp +  4] ; The name of the loaded module
        mov    eax, 0xffffffff
        ret    4
restore lpPathName
;**********************************************************************************
align 16
_SetCurrentDirectoryA@4:
lpPathName     equ [esp +  4 +1*4] ; path to new current directory
        push   ebx

        mov    eax, 30
        mov    ebx, 1
        mov    ecx, lpPathName
        int    64
        xor    eax, eax
        dec    eax

        pop    ebx
        ret    4
restore lpPathName
;**********************************************************************************
align 16
_memset:
ptr     equ    [esp +  4 +1*4] ; Pointer to block of memory to fill
value   equ    [esp +  8 +1*4] ; Value to be set
num     equ    [esp + 12 +1*4] ; Number of bytes to set to value
        push   edi
        mov    edi, ptr
        mov    edx, num
        mov    eax, value
        mov    ah, al
        shl    eax, 8        
        mov    al, ah
        shl    eax, 8        
        mov    al, ah        
        mov    ecx, edx
        shr    ecx, 2
        and    edx, 3
        rep stosd
        mov    ecx, edx
        rep stosb        
        mov    eax, ptr        
        pop    edi
        ret
restore ptr
restore value
restore num
;**********************************************************************************